/***************************************************************************
                            kde_KMenuBar.h -  description
                             -------------------
    begin                : Wed Feb  6 15:12:26 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Wed Feb  6 15:12:26 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_KMENUBAR
#define KDE_KMENUBAR

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**

 KDE Style-able menubar.

 This is required since @ref QMenuBar is currently not handled by
 @ref QStyle.

 @author Daniel "Mosfet" Duley.

 @version $Id: kde_KMenuBar.h,v 1.3 2002/02/21 00:43:12 rdale Exp $

 @short 
 KDE Style-able menubar.
*/
kde_KMenuBar * kde_new_KMenuBar(qt_QWidget * parent, char* name);
void kde_del_KMenuBar( kde_KMenuBar* p );

/** 
 This controls whether or not this menubar will be a top-level
 bar similar to the way Macintosh handles menubars.  This
 overrides any global config settings.

 Keep in mind that it is probably a really bad idea to use this
 unless you really know what you're doing.  A feature like a
 top-level menubar is one that should really be shared by all
 applications.  If your app is the only one with a top-level
 bar, then things might look very... odd.

 This is included only for those people that @p do know that
 they need to use it.

*/
void kde_KMenuBar_setTopLevelMenu(kde_KMenuBar* instPointer,int top_level);

/** 
 Is our menubar a top-level (Macintosh style) menubar?

*/
int kde_KMenuBar_isTopLevelMenu(kde_KMenuBar* instPointer);
void kde_KMenuBar_show(kde_KMenuBar* instPointer);
int kde_KMenuBar_eventFilter(kde_KMenuBar* instPointer,qt_QObject * arg1, qt_QEvent * arg2);
void kde_KMenuBar_slotReadConfig(kde_KMenuBar* instPointer);

#endif
