/***************************************************************************
                            kde_KShortcut.h -  description
                             -------------------
    begin                : Wed Feb  6 15:12:26 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Wed Feb  6 15:12:26 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_KSHORTCUT
#define KDE_KSHORTCUT

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**

 The KShortcut class is used to represent a keyboard shortcut to an action.
 A shortcut is normally a single key with modifiers, such as Ctrl+V.
 A KShortcut object may also contain an alternate key which will also
 activate the action it's associated to, as long as no other actions have
 defined that key as their primary key.  Ex: Ctrl+V;Shift+Insert.
 
 @short 
 The KShortcut class is used to represent a keyboard shortcut to an action.
*/
#define KSHORTCUT_MAX_SEQUENCES	2
kde_KShortcut * kde_new_KShortcut();
kde_KShortcut * kde_new_KShortcut1(int keyQt);
kde_KShortcut * kde_new_KShortcut2(qt_QKeySequence* arg1);
kde_KShortcut * kde_new_KShortcut3(kde_KKey* arg1);
kde_KShortcut * kde_new_KShortcut4(kde_KKeySequence* arg1);
kde_KShortcut * kde_new_KShortcut5(kde_KShortcut* arg1);
kde_KShortcut * kde_new_KShortcut6(char* arg1);
kde_KShortcut * kde_new_KShortcut7(qt_QString * arg1);
void kde_del_KShortcut( kde_KShortcut* p );
void kde_KShortcut_clear(kde_KShortcut* instPointer);
int kde_KShortcut_init(kde_KShortcut* instPointer,int keyQt);
int kde_KShortcut_init1(kde_KShortcut* instPointer,qt_QKeySequence* arg1);
int kde_KShortcut_init2(kde_KShortcut* instPointer,kde_KKey* arg1);
int kde_KShortcut_init3(kde_KShortcut* instPointer,kde_KKeySequence* arg1);
int kde_KShortcut_init4(kde_KShortcut* instPointer,kde_KShortcut* arg1);
int kde_KShortcut_init5(kde_KShortcut* instPointer,qt_QString * arg1);
unsigned int kde_KShortcut_count(kde_KShortcut* instPointer);
kde_KKeySequence* kde_KShortcut_seq(kde_KShortcut* instPointer,unsigned int i);
int kde_KShortcut_keyCodeQt(kde_KShortcut* instPointer);
int kde_KShortcut_isNull(kde_KShortcut* instPointer);
int kde_KShortcut_compare(kde_KShortcut* instPointer,kde_KShortcut* arg1);
int kde_KShortcut_contains(kde_KShortcut* instPointer,kde_KKey* arg1);
int kde_KShortcut_contains1(kde_KShortcut* instPointer,kde_KKeyNative* arg1);
int kde_KShortcut_contains2(kde_KShortcut* instPointer,kde_KKeySequence* arg1);
int kde_KShortcut_setSeq(kde_KShortcut* instPointer,unsigned int i, kde_KKeySequence* arg1);
int kde_KShortcut_append(kde_KShortcut* instPointer,kde_KKeySequence* arg1);
qt_QString * kde_KShortcut_toString(kde_KShortcut* instPointer);
qt_QString * kde_KShortcut_toStringInternal(kde_KShortcut* instPointer,kde_KShortcut* pcutDefault);
kde_KShortcut* kde_KShortcut_null( );

#endif
